diff --git a/src/backend/utils/cache/catcache.c b/src/backend/utils/cache/catcache.c
index 64776e3..0d807c3 100644
--- a/src/backend/utils/cache/catcache.c
+++ b/src/backend/utils/cache/catcache.c
@@ -39,6 +39,14 @@
 #include "utils/resowner_private.h"
 #include "utils/syscache.h"
 
+#define CATC_HANDLE_VALID(localCatCTup) \
+	((localCatCTup)->lct_generation == localCatCTup->lct_handle->generation)
+
+#define CATC_IS_INVALID_DUMMY(localCatCTup) \
+	((localCatCTup)->lct_skip_global_subxid != InvalidSubTransactionId)
+
+/**/
+#define MAX_CC_BUCKET_LOCKS 64
 
  /* #define CACHEDEBUG */	/* turns DEBUG elogs on */
 
@@ -60,6 +68,39 @@
 #define CACHE_elog(...)
 #endif
 
+
+/* structs for Global CatCache */
+struct GlobalCatCache
+{
+	CatCache gcc_catcache; 	/* normal CatCache */
+	slock_t gcc_mutex; 	/* lock for CatCache itself */
+	LWLock *gcc_bucket_locks;	/* locks for buckets */
+	HandleHeader gcc_handle_hdr; /* handle */
+};
+
+/* struct for Global CatCtup */
+struct LocalCatCTup
+{
+	CatCTup lct_ct;		/* regular CatCTup */
+	Handle *lct_handle; /* handle pointing to global cache entry */
+	int lct_generation; /* handle generation to check handle validity */
+	bool lct_committed; /* committed or not */
+	/*
+	 * lct_skip_global_subxid is xid this entry is invalidated. In the
+	 * middle of xact, regular catctup is removed or gets dead by local
+	 * invalidation messages. However, SharedLocal cache
+	 */
+	SubTransactionId lct_skip_global_subxid;  /* lct was invalidated in this xaxt */
+};
+
+/* struct for Global CatCtup */
+struct GlobalCatCTup
+{
+	CatCTup gct_ct;    	/* regular CatCTup */
+	Handle *gct_handle; /* handle */
+	slock_t gct_mutex; 	/* lock for refcount/dead of CatCTup */
+};
+
 /* Cache management header --- pointer is NULL until created */
 static CatCacheHeader *CacheHdr = NULL;
 
@@ -79,10 +120,12 @@ static uint32 CatalogCacheComputeHashValue(CatCache *cache, int nkeys,
 										   Datum v1, Datum v2, Datum v3, Datum v4);
 static uint32 CatalogCacheComputeTupleHashValue(CatCache *cache, int nkeys,
 												HeapTuple tuple);
-static inline bool CatalogCacheCompareTuple(const CatCache *cache, int nkeys,
+static inline bool CatalogCacheCompareTuple(const CCFastEqualFN *gcc_fastequal,
+											int nkeys,
 											const Datum *cachekeys,
 											const Datum *searchkeys);
 
+
 #ifdef CATCACHE_STATS
 static void CatCachePrintStats(int code, Datum arg);
 #endif
@@ -92,13 +135,45 @@ static void CatalogCacheInitializeCache(CatCache *cache);
 static CatCTup *CatalogCacheCreateEntry(CatCache *cache, HeapTuple ntp,
 										Datum *arguments,
 										uint32 hashValue, Index hashIndex,
-										bool negative);
+										bool negative, Handle* handle);
 
 static void CatCacheFreeKeys(TupleDesc tupdesc, int nkeys, int *attnos,
 							 Datum *keys);
 static void CatCacheCopyKeys(TupleDesc tupdesc, int nkeys, int *attnos,
 							 Datum *srckeys, Datum *dstkeys);
 
+static void InitLocalCatCacheInternal(CatCache *cache);
+static void InitGlobalCatCache(CatCache *local_cache, GlobalCatCacheMapKey *keyPtr);
+static GlobalCatCache *InitGlobalCatCacheInternal(CatCache *local_cache);
+static GlobalCatCache *AttachGlobalCatCache(GlobalCatCacheMapKey *keyPtr);
+
+static CatCTup *
+SearchCatCacheBucket(CatCache *cache, int nkeys, Datum *searchkeys,
+					 uint32 hashValue, Index hashIndex,
+					 const CCFastEqualFN *gcc_fastequal);
+
+static CatCTup *
+CreateCatCTupWithTuple(CatCache *cache, HeapTuple ntp);
+static CatCTup *CreateCatCTupWithoutTuple(CatCache *cache, Datum *arguments);
+static CatCTup *
+LocalCacheGetValidEntry(LocalCatCTup *lct);
+
+static LWLock *
+GetCatCacheBucketLock(GlobalCatCache *gcp, uint32 hashValue);
+static void ReleaseLocalCtlistItem(CatCache *cache, List *ctlist);
+static void IncreaceGlobalCatCTupRefCount(GlobalCatCTup *gct);
+static void GlobalCatCacheRemoveCTup(GlobalCatCache *gcp, GlobalCatCTup *gct);
+static void
+GlobalCatCTupDecrementAndRemove(GlobalCatCache *gcp, GlobalCatCTup *gct);
+static void CatCacheInvalidateInternal(CatCache *local_cach, CatCTup *ct);
+static void	CreateInvalCatalogCache(CatCache *cache, uint32 hashValue);
+static void ResetRemoveCatalogCache(CatCache *cache);
+static void SetSkipGlobalSubxid(CatCache *cache);
+static void ResetSkipGlobalSubxid(CatCache *cache);
+static bool SkipGlobalSubxidIsOwnOrChild(CatCache *cache);
+static void ResetGlobalCatalogCache(CatCache *local_cache);
+static void GlobalCatCacheInvalInternal(GlobalCatCache *gcp,
+										CatCTup *global_ct);
 
 /*
  *					internal support functions
@@ -371,11 +446,10 @@ CatalogCacheComputeTupleHashValue(CatCache *cache, int nkeys, HeapTuple tuple)
  * Compare a tuple to the passed arguments.
  */
 static inline bool
-CatalogCacheCompareTuple(const CatCache *cache, int nkeys,
+CatalogCacheCompareTuple(const CCFastEqualFN *cc_fastequal, int nkeys,
 						 const Datum *cachekeys,
 						 const Datum *searchkeys)
 {
-	const CCFastEqualFN *cc_fastequal = cache->cc_fastequal;
 	int			i;
 
 	for (i = 0; i < nkeys; i++)
@@ -388,7 +462,6 @@ CatalogCacheCompareTuple(const CatCache *cache, int nkeys,
 
 
 #ifdef CATCACHE_STATS
-
 static void
 CatCachePrintStats(int code, Datum arg)
 {
@@ -420,7 +493,8 @@ CatCachePrintStats(int code, Datum arg)
 			 cache->cc_searches - cache->cc_hits - cache->cc_neg_hits,
 			 cache->cc_invals,
 			 cache->cc_lsearches,
-			 cache->cc_lhits);
+			 cache->cc_lhits
+			);
 		cc_searches += cache->cc_searches;
 		cc_hits += cache->cc_hits;
 		cc_neg_hits += cache->cc_neg_hits;
@@ -458,6 +532,7 @@ CatCacheRemoveCTup(CatCache *cache, CatCTup *ct)
 {
 	Assert(ct->refcount == 0);
 	Assert(ct->my_cache == cache);
+	Assert(cache->cc_type != CC_SHAREDGLOBAL);
 
 	if (ct->c_list)
 	{
@@ -482,6 +557,14 @@ CatCacheRemoveCTup(CatCache *cache, CatCTup *ct)
 		CatCacheFreeKeys(cache->cc_tupdesc, cache->cc_nkeys,
 						 cache->cc_keyno, ct->keys);
 
+	if (cache->cc_type == CC_SHAREDLOCAL)
+	{
+		/* Committed tuple is not negative but has keys. */
+		if (((LocalCatCTup *)ct)->lct_committed)
+			CatCacheFreeKeys(cache->cc_tupdesc, cache->cc_nkeys,
+							 cache->cc_keyno, ct->keys);
+	}
+
 	pfree(ct);
 
 	--cache->cc_ntup;
@@ -489,6 +572,85 @@ CatCacheRemoveCTup(CatCache *cache, CatCTup *ct)
 }
 
 /*
+ *		GlobalCatCTupDecrementAndRemove
+ *
+ * Release the reference counter of global cache entry. If cache entry is
+ * dead and referenced by one process alone, it's removed.
+ */
+static void
+GlobalCatCTupDecrementAndRemove(GlobalCatCache *gcp, GlobalCatCTup *gct)
+{
+	CatCTup *ct = (CatCTup *)gct;
+	LWLock *bucket_lock;
+
+	Assert(ct->my_cache == (CatCache *)gcp);
+	Assert(ct->my_cache->cc_type == CC_SHAREDGLOBAL);
+
+	SpinLockAcquire(&gct->gct_mutex);
+
+	Assert(ct->refcount > 0);
+
+	if (ct->dead && ct->refcount == 1)
+		SpinLockRelease(&gct->gct_mutex);
+	else
+	{
+		ct->refcount--;
+		SpinLockRelease(&gct->gct_mutex);
+		return;
+	}
+
+	/*
+	 * Here spin lock is not needed. Dead cache entry is never newly fetched.
+	 * So dead cache with refcount one is referenced only by this process.
+	 */
+	ct->refcount--;
+
+	bucket_lock = GetCatCacheBucketLock(gcp, ct->hash_value);
+
+	LWLockAcquire(bucket_lock, LW_EXCLUSIVE);
+	GlobalCatCacheRemoveCTup(gcp, gct);
+	LWLockRelease(bucket_lock);
+}
+
+/*
+ *		GlobalCatCacheRemoveCTup
+ *
+ * Unlink and delete the given global cache entry.
+ * This assumes that the bucket lock is aquired by the caller because multiple
+ * entries in one bucket are possibly removed recursively.
+ */
+static void
+GlobalCatCacheRemoveCTup(GlobalCatCache *gcp, GlobalCatCTup *gct)
+{
+	CatCTup *ct = (CatCTup *)gct;
+	LWLock *handle_lock;
+
+	Assert(ct->refcount == 0);
+
+	handle_lock = GET_HANDLE_LOCK(gct->gct_handle);
+	LWLockAcquire(handle_lock, LW_EXCLUSIVE);
+
+	/* delete from hash table */
+	dlist_delete(&ct->cache_elem);
+
+	/* invalidate handle */
+	Assert(gct->gct_handle->entry == gct);
+	InvalCacheHandle(&gcp->gcc_handle_hdr, gct->gct_handle);
+	LWLockRelease(handle_lock);
+
+	/*
+	 * Free after releasing hadnle lock is safe because no other process cannot
+	 * access this entry here.
+	 */
+	pfree(gct);
+
+	SpinLockAcquire(&gcp->gcc_mutex);
+	((CatCache *)gcp)->cc_ntup--;
+	SpinLockRelease(&gcp->gcc_mutex);
+}
+
+
+/*
  *		CatCacheRemoveCList
  *
  * Unlink and delete the given cache list entry
@@ -502,11 +664,16 @@ CatCacheRemoveCList(CatCache *cache, CatCList *cl)
 
 	Assert(cl->refcount == 0);
 	Assert(cl->my_cache == cache);
+	Assert(cache->cc_type != CC_SHAREDGLOBAL);
 
 	/* delink from member tuples */
 	for (i = cl->n_members; --i >= 0;)
 	{
-		CatCTup    *ct = cl->members[i];
+		CatCTup    *ct;
+		if (cache->cc_type == CC_REGULAR)
+			ct = cl->members[i];
+		else
+			ct = (CatCTup *)cl->shared_local_members[i];
 
 		Assert(ct->c_list == cl);
 		ct->c_list = NULL;
@@ -526,6 +693,9 @@ CatCacheRemoveCList(CatCache *cache, CatCList *cl)
 	CatCacheFreeKeys(cache->cc_tupdesc, cl->nkeys,
 					 cache->cc_keyno, cl->keys);
 
+	if (cache->cc_type == CC_SHAREDLOCAL)
+		pfree(cl->shared_local_members);
+
 	pfree(cl);
 }
 
@@ -549,10 +719,12 @@ CatCacheRemoveCList(CatCache *cache, CatCList *cl)
  *	This routine is only quasi-public: it should only be used by inval.c.
  */
 void
-CatCacheInvalidate(CatCache *cache, uint32 hashValue)
+CatCacheInvalidate(CatCache *cache, uint32 hashValue, InvalPhase invalPhase)
 {
 	Index		hashIndex;
 	dlist_mutable_iter iter;
+	LocalCatCTup *lct;
+	bool found_invaldummy = false;
 
 	CACHE_elog(DEBUG2, "CatCacheInvalidate: called");
 
@@ -585,22 +757,164 @@ CatCacheInvalidate(CatCache *cache, uint32 hashValue)
 
 		if (hashValue == ct->hash_value)
 		{
-			if (ct->refcount > 0 ||
-				(ct->c_list && ct->c_list->refcount > 0))
+			switch (invalPhase)
 			{
-				ct->dead = true;
-				/* list, if any, was marked dead above */
-				Assert(ct->c_list == NULL || ct->c_list->dead);
-			}
-			else
-				CatCacheRemoveCTup(cache, ct);
-			CACHE_elog(DEBUG2, "CatCacheInvalidate: invalidated");
+				case INVAL_COMMON:
+				case INVAL_GMC_ABORT_XACT:
+					CatCacheInvalidateInternal(cache, ct);
+
+					CACHE_elog(DEBUG2, "CatCacheInvalidate: invalidated");
 #ifdef CATCACHE_STATS
-			cache->cc_invals++;
+					cache->cc_invals++;
 #endif
+					break;
+
+				case INVAL_GMC_EO_COMMAND:
+				case INVAL_GMC_COMMIT_SUBXACT:
+					lct = (LocalCatCTup *)ct;
+
+					if (CATC_IS_INVALID_DUMMY(lct))
+					{
+						found_invaldummy = true;
+						continue;
+					}
+
+					CatCacheInvalidateInternal(cache, ct);
+					break;
+
+				case INVAL_GMC_COMMIT_XACT:
+					lct = (LocalCatCTup *)ct;
+
+					if (lct->lct_committed || !CATC_IS_INVALID_DUMMY(lct))
+						continue;
+
+					CatCacheInvalidateInternal(cache, ct);
+					break;
+
+				case INVAL_GMC_ABORT_SUBXACT:
+					lct = (LocalCatCTup *)ct;
+
+					/*
+					 * if found one has skip-flag and it's set by parent's
+					 * transaction, that dummy cache cannot be erased.
+					 */
+					if (lct->lct_skip_global_subxid != InvalidSubTransactionId &&
+						lct->lct_skip_global_subxid < GetCurrentSubTransactionId())
+						continue;
+
+					CatCacheInvalidateInternal(cache, ct);
+					break;
+			}
+			/* could be multiple matches, so keep looking! */
+		}
+	}
+
+	/*
+	 * Create a dummy cache with subxid to prevent upcoming command from
+	 * searching global cache instead of actual system catalog.
+	 */
+	if (invalPhase == INVAL_GMC_EO_COMMAND && !found_invaldummy)
+		CreateInvalCatalogCache(cache, hashValue);
+
+}
+
+static void
+CatCacheInvalidateInternal(CatCache *local_cache, CatCTup *ct)
+{
+	Assert(local_cache->cc_type != CC_SHAREDGLOBAL);
+
+	if (ct->refcount > 0 ||
+		(ct->c_list && ct->c_list->refcount > 0))
+	{
+		ct->dead = true;
+		/* list, if any, was marked dead in CatCacheInvalidate */
+		Assert(ct->c_list == NULL || ct->c_list->dead);
+	}
+	else
+		CatCacheRemoveCTup(local_cache, ct);
+}
+
+static void
+CreateInvalCatalogCache(CatCache *cache, uint32 hashValue)
+{
+	Index hashIndex;
+
+	Assert(cache->cc_type == CC_SHAREDLOCAL);
+
+	hashIndex = HASH_INDEX(hashValue, cache->cc_nbuckets);
+
+	CatalogCacheCreateEntry(cache, NULL, NULL,
+							hashValue, hashIndex,
+							false, NULL);
+
+}
+
+void
+GlobalCatCacheInvalidate(CatCache *local_cache, uint32 hashValue)
+{
+	CatCache *global_cache;
+	Index		hashIndex;
+	dlist_mutable_iter iter;
+	LWLock *bucket_lock;
+
+	CACHE_elog(DEBUG2, "GlobalCatCacheInvalidate: called");
+
+	/*
+	 * We don't bother to check whether the cache has finished initialization
+	 * yet; if not, there will be no entries in it so no problem.
+	 *
+	 * We don't also care CatCList because there is no global CatCList.
+	 */
+
+	/*
+	 * inspect the proper hash bucket of global hash table
+	 */
+
+	/* First acquire lock for bucket */
+	bucket_lock = GetCatCacheBucketLock(local_cache->gcp, hashValue);
+
+	LWLockAcquire(bucket_lock, LW_EXCLUSIVE);
+
+	global_cache = (CatCache *)local_cache->gcp;
+
+	hashIndex = HASH_INDEX(hashValue, global_cache->cc_nbuckets);
+
+	dlist_foreach_modify(iter, &global_cache->cc_bucket[hashIndex])
+	{
+		CatCTup    *ct = dlist_container(CatCTup, cache_elem, iter.cur);
+
+		if (hashValue == ct->hash_value)
+		{
+			GlobalCatCacheInvalInternal(local_cache->gcp, ct);
+
+			CACHE_elog(DEBUG2, "GlobalCatCacheInvalidate: invalidated");
+
 			/* could be multiple matches, so keep looking! */
 		}
 	}
+
+	LWLockRelease(bucket_lock);
+}
+
+/*
+ * Lock to bucket should be aquired by the caller
+ */
+static void
+GlobalCatCacheInvalInternal(GlobalCatCache *gcp, CatCTup *global_ct)
+{
+	slock_t *gct_mutex;
+	GlobalCatCTup *gct = (GlobalCatCTup *)global_ct;
+
+	if (global_ct->refcount > 0)
+	{
+		/* Get lock for CatCTup */
+		gct_mutex = &gct->gct_mutex;
+		SpinLockAcquire(gct_mutex);
+		global_ct->dead = true;
+		SpinLockRelease(gct_mutex);
+	}
+	else
+		GlobalCatCacheRemoveCTup(gcp, gct);
 }
 
 /* ----------------------------------------------------------------
@@ -629,7 +943,6 @@ CreateCacheMemoryContext(void)
 												   ALLOCSET_DEFAULT_SIZES);
 }
 
-
 /*
  *		ResetCatalogCache
  *
@@ -639,10 +952,9 @@ CreateCacheMemoryContext(void)
  * However, it shouldn't need to be efficient; we don't invoke it often.
  */
 static void
-ResetCatalogCache(CatCache *cache)
+ResetCatalogCache(CatCache *cache, InvalPhase invalPhase)
 {
 	dlist_mutable_iter iter;
-	int			i;
 
 	/* Remove each list in this cache, or at least mark it dead */
 	dlist_foreach_modify(iter, &cache->cc_lists)
@@ -655,6 +967,65 @@ ResetCatalogCache(CatCache *cache)
 			CatCacheRemoveCList(cache, cl);
 	}
 
+	switch (invalPhase)
+	{
+		case INVAL_COMMON:
+		case INVAL_GMC_ABORT_XACT: /* this label is not used */
+
+			/*
+			 * When GMC is off and some cases when GMC is on; accepting sinval
+			 * or abort transaction.
+			 */
+			ResetRemoveCatalogCache(cache);
+
+			if (cache->cc_type == CC_SHAREDLOCAL)
+				ResetSkipGlobalSubxid(cache);
+
+			break;
+
+		case INVAL_GMC_EO_COMMAND:
+		case INVAL_GMC_COMMIT_SUBXACT: /* this label is not used */
+			ResetRemoveCatalogCache(cache);
+
+			/* Mark skip flag not to search global cache */
+			SetSkipGlobalSubxid(cache);
+			break;
+
+		case INVAL_GMC_COMMIT_XACT:
+			/* ResetRemoveCatalogCache is not called  */
+			ResetGlobalCatalogCache(cache);
+			ResetSkipGlobalSubxid(cache);
+			break;
+
+		case INVAL_GMC_ABORT_SUBXACT:
+			ResetGlobalCatalogCache(cache);
+
+			/*
+			 * Reset skip-flag only if it's set by current subtransaction or
+			 * children's subtransaction not to affect parent's subtransaction.
+			 */
+			if (SkipGlobalSubxidIsOwnOrChild(cache))
+				ResetSkipGlobalSubxid(cache);
+
+			break;
+	}
+}
+
+
+/*
+ * ResetRemoveCatalogCache
+ *   Workhorse for ResetRemoveCatalogCache
+ *   This fucntion invalidates all caches and reset skip_global_subxid only if
+ *   GMC is on.
+ */
+static void
+ResetRemoveCatalogCache(CatCache *cache)
+{
+	dlist_mutable_iter iter;
+	int  i;
+
+	Assert(cache->cc_type != CC_SHAREDGLOBAL);
+
 	/* Remove each tuple in this cache, or at least mark it dead */
 	for (i = 0; i < cache->cc_nbuckets; i++)
 	{
@@ -678,6 +1049,69 @@ ResetCatalogCache(CatCache *cache)
 #endif
 		}
 	}
+
+}
+
+static void
+SetSkipGlobalSubxid(CatCache *cache)
+{
+	Assert(cache->cc_type == CC_SHAREDLOCAL);
+
+	cache->cc_skip_global_subxid = GetCurrentSubTransactionId();
+}
+
+static void
+ResetSkipGlobalSubxid(CatCache *cache)
+{
+	Assert(cache->cc_type == CC_SHAREDLOCAL);
+
+	cache->cc_skip_global_subxid = InvalidSubTransactionId;
+}
+
+static bool
+SkipGlobalSubxidIsOwnOrChild(CatCache *cache)
+{
+	return cache->cc_skip_global_subxid >= GetCurrentSubTransactionId();
+}
+
+static void
+ResetGlobalCatalogCache(CatCache *local_cache)
+{
+	CatCache *global_cache;
+	GlobalCatCache *gcp;
+	dlist_mutable_iter iter;
+	int			i;
+	int num_locks;
+
+	Assert(local_cache->cc_type == CC_SHAREDLOCAL);
+
+	/* global cache doesn't have cc_lists */
+
+	/* Get the corresponding cache and aquire locks */
+	gcp = local_cache->gcp;
+	global_cache = (CatCache *)gcp;
+
+	num_locks = MAX_CC_BUCKET_LOCKS;
+
+	for (i = 0; i < num_locks; ++i)
+		LWLockAcquire(&gcp->gcc_bucket_locks[i], LW_EXCLUSIVE);
+
+	/* Remove each tuple in this cache, or at least mark it dead */
+	for (i = 0; i < global_cache->cc_nbuckets; i++)
+	{
+		dlist_head *bucket = &global_cache->cc_bucket[i];
+
+		dlist_foreach_modify(iter, bucket)
+		{
+			CatCTup    *ct = dlist_container(CatCTup, cache_elem, iter.cur);
+
+			GlobalCatCacheInvalInternal(gcp, ct);
+		}
+	}
+
+	/* Release locks in reverse order */
+	for (i = num_locks - 1 ; i >= 0; --i)
+		LWLockRelease(&gcp->gcc_bucket_locks[i]);
 }
 
 /*
@@ -696,7 +1130,7 @@ ResetCatalogCaches(void)
 	{
 		CatCache   *cache = slist_container(CatCache, cc_next, iter.cur);
 
-		ResetCatalogCache(cache);
+		ResetCatalogCache(cache, INVAL_COMMON);
 	}
 
 	CACHE_elog(DEBUG2, "end of ResetCatalogCaches call");
@@ -716,7 +1150,7 @@ ResetCatalogCaches(void)
  *	this assumes the tupdesc of a cachable system table will not change...)
  */
 void
-CatalogCacheFlushCatalog(Oid catId)
+CatalogCacheFlushCatalog(Oid catId, InvalPhase invalPhase)
 {
 	slist_iter	iter;
 
@@ -730,7 +1164,7 @@ CatalogCacheFlushCatalog(Oid catId)
 		if (cache->cc_reloid == catId)
 		{
 			/* Yes, so flush all its contents */
-			ResetCatalogCache(cache);
+			ResetCatalogCache(cache, invalPhase);
 
 			/* Tell inval.c to call syscache callbacks for this cache */
 			CallSyscacheCallbacks(cache->id, 0);
@@ -740,6 +1174,7 @@ CatalogCacheFlushCatalog(Oid catId)
 	CACHE_elog(DEBUG2, "end of CatalogCacheFlushCatalog call");
 }
 
+
 /*
  *		InitCatCache
  *
@@ -817,6 +1252,11 @@ InitCatCache(int id,
 	cp = (CatCache *) CACHELINEALIGN(palloc0(sz));
 	cp->cc_bucket = palloc0(nbuckets * sizeof(dlist_head));
 
+	if (!IS_GLOBAL_META_CACHE)
+		cp->cc_type = CC_REGULAR;
+	else
+		cp->cc_type = CC_SHAREDLOCAL;
+
 	/*
 	 * initialize the cache's relation information for the relation
 	 * corresponding to this cache, and initialize some of the new cache's
@@ -831,6 +1271,8 @@ InitCatCache(int id,
 	cp->cc_ntup = 0;
 	cp->cc_nbuckets = nbuckets;
 	cp->cc_nkeys = nkeys;
+	cp->gcp = (GlobalCatCache *) NULL;
+	cp->cc_skip_global_subxid = InvalidSubTransactionId;
 	for (i = 0; i < nkeys; ++i)
 		cp->cc_keyno[i] = key[i];
 
@@ -860,15 +1302,36 @@ static void
 RehashCatCache(CatCache *cp)
 {
 	dlist_head *newbucket;
-	int			newnbuckets;
+	int		    newnbuckets;
 	int			i;
+	MemoryContext Context = NULL;
+	MemoryContext TempGlobalCatCacheContext = NULL;
 
-	elog(DEBUG1, "rehashing catalog cache id %d for %s; %d tups, %d buckets",
-		 cp->id, cp->cc_relname, cp->cc_ntup, cp->cc_nbuckets);
+	elog(DEBUG1, "rehashing catalog cache id %d for %s; %d tups, %d buckets"
+		 ", %d cc_type",
+		 cp->id, cp->cc_relname, cp->cc_ntup, cp->cc_nbuckets, cp->cc_type);
 
 	/* Allocate a new, larger, hash table. */
 	newnbuckets = cp->cc_nbuckets * 2;
-	newbucket = (dlist_head *) MemoryContextAllocZero(CacheMemoryContext, newnbuckets * sizeof(dlist_head));
+
+	if (cp->cc_type == CC_REGULAR || cp->cc_type == CC_SHAREDLOCAL)
+		Context = CacheMemoryContext;
+	else /* CC_SHAREDGLOBAL */
+	{
+		/*
+		 * CurrentContext is assumed to be transient so that it will be
+		 * cleaned up on error.
+		 */
+		TempGlobalCatCacheContext = MemoryContextClone(GlobalCatCacheContext,
+													   CurrentMemoryContext);
+		Context = TempGlobalCatCacheContext;
+	}
+
+	newbucket = (dlist_head *) MemoryContextAllocZero(Context,
+													  newnbuckets *
+													  sizeof(dlist_head));
+
+
 
 	/* Move all entries from old hash table to new. */
 	for (i = 0; i < cp->cc_nbuckets; i++)
@@ -889,6 +1352,9 @@ RehashCatCache(CatCache *cp)
 	pfree(cp->cc_bucket);
 	cp->cc_nbuckets = newnbuckets;
 	cp->cc_bucket = newbucket;
+
+	if (cp->cc_type == CC_SHAREDGLOBAL)
+		ShmRetailContextMoveChunk(TempGlobalCatCacheContext, GlobalCatCacheContext);
 }
 
 /*
@@ -922,102 +1388,26 @@ do { \
 static void
 CatalogCacheInitializeCache(CatCache *cache)
 {
-	Relation	relation;
-	MemoryContext oldcxt;
-	TupleDesc	tupdesc;
-	int			i;
+	GlobalCatCacheMapKey key;
 
 	CatalogCacheInitializeCache_DEBUG1;
 
-	relation = table_open(cache->cc_reloid, AccessShareLock);
-
-	/*
-	 * switch to the cache context so our allocations do not vanish at the end
-	 * of a transaction
-	 */
-	Assert(CacheMemoryContext != NULL);
-
-	oldcxt = MemoryContextSwitchTo(CacheMemoryContext);
+	if (cache->cc_type == CC_REGULAR)
+		InitLocalCatCacheInternal(cache);
+	else
+	{
+		Assert(cache->cc_type == CC_SHAREDLOCAL);
 
-	/*
-	 * copy the relcache's tuple descriptor to permanent cache storage
-	 */
-	tupdesc = CreateTupleDescCopyConstr(RelationGetDescr(relation));
+		/* Fill in local CatCache members */
+		InitLocalCatCacheInternal(cache);
 
-	/*
-	 * save the relation's name and relisshared flag, too (cc_relname is used
-	 * only for debugging purposes)
-	 */
-	cache->cc_relname = pstrdup(RelationGetRelationName(relation));
-	cache->cc_relisshared = RelationGetForm(relation)->relisshared;
-
-	/*
-	 * return to the caller's memory context and close the rel
-	 */
-	MemoryContextSwitchTo(oldcxt);
-
-	table_close(relation, AccessShareLock);
-
-	CACHE_elog(DEBUG2, "CatalogCacheInitializeCache: %s, %d keys",
-			   cache->cc_relname, cache->cc_nkeys);
-
-	/*
-	 * initialize cache's key information
-	 */
-	for (i = 0; i < cache->cc_nkeys; ++i)
-	{
-		Oid			keytype;
-		RegProcedure eqfunc;
-
-		CatalogCacheInitializeCache_DEBUG2;
-
-		if (cache->cc_keyno[i] > 0)
-		{
-			Form_pg_attribute attr = TupleDescAttr(tupdesc,
-												   cache->cc_keyno[i] - 1);
-
-			keytype = attr->atttypid;
-			/* cache key columns should always be NOT NULL */
-			Assert(attr->attnotnull);
-		}
-		else
-		{
-			if (cache->cc_keyno[i] < 0)
-				elog(FATAL, "sys attributes are not supported in caches");
-			keytype = OIDOID;
-		}
-
-		GetCCHashEqFuncs(keytype,
-						 &cache->cc_hashfunc[i],
-						 &eqfunc,
-						 &cache->cc_fastequal[i]);
-
-		/*
-		 * Do equality-function lookup (we assume this won't need a catalog
-		 * lookup for any supported type)
-		 */
-		fmgr_info_cxt(eqfunc,
-					  &cache->cc_skey[i].sk_func,
-					  CacheMemoryContext);
-
-		/* Initialize sk_attno suitably for HeapKeyTest() and heap scans */
-		cache->cc_skey[i].sk_attno = cache->cc_keyno[i];
-
-		/* Fill in sk_strategy as well --- always standard equality */
-		cache->cc_skey[i].sk_strategy = BTEqualStrategyNumber;
-		cache->cc_skey[i].sk_subtype = InvalidOid;
-		/* If a catcache key requires a collation, it must be C collation */
-		cache->cc_skey[i].sk_collation = C_COLLATION_OID;
-
-		CACHE_elog(DEBUG2, "CatalogCacheInitializeCache %s %d %p",
-				   cache->cc_relname, i, cache);
-	}
-
-	/*
-	 * mark this cache fully initialized
-	 */
-	cache->cc_tupdesc = tupdesc;
-}
+		/* Attach to global CatCache. If not exist, initialize it */
+		GlobalCatCacheMapInitKey(cache, &key);
+		cache->gcp = AttachGlobalCatCache(&key);
+		if (!cache->gcp)
+			InitGlobalCatCache(cache, &key);
+	}
+}
 
 /*
  * InitCatCachePhase2 -- external interface for CatalogCacheInitializeCache
@@ -1195,7 +1585,7 @@ SearchCatCache4(CatCache *cache,
  * Work-horse for SearchCatCache/SearchCatCacheN.
  */
 static inline HeapTuple
-SearchCatCacheInternal(CatCache *cache,
+SearchCatCacheInternal(CatCache *local_cache,
 					   int nkeys,
 					   Datum v1,
 					   Datum v2,
@@ -1204,24 +1594,27 @@ SearchCatCacheInternal(CatCache *cache,
 {
 	Datum		arguments[CATCACHE_MAXKEYS];
 	uint32		hashValue;
-	Index		hashIndex;
-	dlist_iter	iter;
-	dlist_head *bucket;
-	CatCTup    *ct;
+	Index		local_hashIndex;
+	Index 		global_hashIndex;
+	CatCache *global_cache;
+	CatCTup    *local_ct;
+	CatCTup	   *global_ct;
 
 	/* Make sure we're in an xact, even if this ends up being a cache hit */
 	Assert(IsTransactionState());
 
-	Assert(cache->cc_nkeys == nkeys);
+	Assert(local_cache->cc_nkeys == nkeys);
+
+	Assert(local_cache->cc_type != CC_SHAREDGLOBAL);
 
 	/*
 	 * one-time startup overhead for each cache
 	 */
-	if (unlikely(cache->cc_tupdesc == NULL))
-		CatalogCacheInitializeCache(cache);
+	if (unlikely(local_cache->cc_tupdesc == NULL))
+		CatalogCacheInitializeCache(local_cache);
 
 #ifdef CATCACHE_STATS
-	cache->cc_searches++;
+	local_cache->cc_searches++;
 #endif
 
 	/* Initialize local parameter array */
@@ -1233,70 +1626,108 @@ SearchCatCacheInternal(CatCache *cache,
 	/*
 	 * find the hash bucket in which to look for the tuple
 	 */
-	hashValue = CatalogCacheComputeHashValue(cache, nkeys, v1, v2, v3, v4);
-	hashIndex = HASH_INDEX(hashValue, cache->cc_nbuckets);
+	hashValue = CatalogCacheComputeHashValue(local_cache, nkeys,
+											 v1, v2, v3, v4);
+	local_hashIndex = HASH_INDEX(hashValue, local_cache->cc_nbuckets);
+
+	/* Search local hash table. If not found, local_ct is NULL */
+	local_ct = SearchCatCacheBucket(local_cache, nkeys, arguments,
+									hashValue, local_hashIndex, NULL);
 
 	/*
-	 * scan the hash bucket until we find a match or exhaust our tuples
-	 *
-	 * Note: it's okay to use dlist_foreach here, even though we modify the
-	 * dlist within the loop, because we don't continue the loop afterwards.
+	 * In case of traditional CatCache, if entry is not found locally,
+	 * consult the actual catalog.
 	 */
-	bucket = &cache->cc_bucket[hashIndex];
-	dlist_foreach(iter, bucket)
+	if (local_cache->cc_type == CC_REGULAR)
 	{
-		ct = dlist_container(CatCTup, cache_elem, iter.cur);
-
-		if (ct->dead)
-			continue;			/* ignore dead entries */
+		/* if ct is found but negative, return NULL */
+		if (local_ct)
+			return !local_ct->negative ? &local_ct->tuple : NULL;
+		else
+			return SearchCatCacheMiss(local_cache, nkeys, hashValue,
+									  local_hashIndex, v1, v2, v3, v4);
+	}
+	else if (local_cache->cc_type == CC_SHAREDLOCAL)
+	{
+		if (local_ct)
+		{
+			CatCTup *temp_ct;
+			LocalCatCTup *lct = (LocalCatCTup *)local_ct;
 
-		if (ct->hash_value != hashValue)
-			continue;			/* quickly skip entry if wrong hash val */
+			if (CATC_IS_INVALID_DUMMY(lct))
+				return SearchCatCacheMiss(local_cache, nkeys, hashValue,
+										  local_hashIndex, v1, v2, v3, v4);
 
-		if (!CatalogCacheCompareTuple(cache, nkeys, ct->keys, arguments))
-			continue;
 
-		/*
-		 * We found a match in the cache.  Move it to the front of the list
-		 * for its hashbucket, in order to speed subsequent searches.  (The
-		 * most frequently accessed elements in any hashbucket will tend to be
-		 * near the front of the hashbucket's list.)
-		 */
-		dlist_move_head(bucket, &ct->cache_elem);
+			/* Get global cache or local uncommitted cache */
+			temp_ct = LocalCacheGetValidEntry(lct);
 
-		/*
-		 * If it's a positive entry, bump its refcount and return it. If it's
-		 * negative, we can report failure to the caller.
-		 */
-		if (!ct->negative)
+			/* if it's valid, early return, otherwise seach global cache */
+			if (temp_ct)
+				return !temp_ct->negative ? &temp_ct->tuple : NULL;
+		}
+		else
 		{
-			ResourceOwnerEnlargeCatCacheRefs(CurrentResourceOwner);
-			ct->refcount++;
-			ResourceOwnerRememberCatCacheRef(CurrentResourceOwner, &ct->tuple);
+			/*
+			 * Cache entry is not found in local hash table. This could be
+			 * because all caches are invalidated by CatalogCacheFlushCatalog.
+			 * Since system catalog is updated in this case, global cache is
+			 * outdated for this transaction.
+			 */
+			if (local_cache->cc_skip_global_subxid != InvalidSubTransactionId)
+				return SearchCatCacheMiss(local_cache, nkeys, hashValue,
+										  local_hashIndex, v1, v2, v3, v4);
 
-			CACHE_elog(DEBUG2, "SearchCatCache(%s): found in bucket %d",
-					   cache->cc_relname, hashIndex);
+		}
+	}
 
-#ifdef CATCACHE_STATS
-			cache->cc_hits++;
-#endif
+	CACHE_elog(DEBUG2, "try to search global cache entry");
+	/*
+	 * Now valid local cache entry is not obtained. Let's search the global hash
+	 * bucket. hashIndex is generally diffrent from local one because of hash
+	 * table expansion.
+	 */
+	global_cache = (CatCache *)local_cache->gcp;
+	global_hashIndex = HASH_INDEX(hashValue, global_cache->cc_nbuckets);
 
-			return &ct->tuple;
-		}
-		else
-		{
-			CACHE_elog(DEBUG2, "SearchCatCache(%s): found neg entry in bucket %d",
-					   cache->cc_relname, hashIndex);
+	/* global cache refcount is bumped if found */
+	global_ct = SearchCatCacheBucket(global_cache,
+									 nkeys, arguments,
+									 hashValue, global_hashIndex,
+									 local_cache->cc_fastequal);
 
-#ifdef CATCACHE_STATS
-			cache->cc_neg_hits++;
-#endif
 
-			return NULL;
-		}
+	/*
+	 * If global entry is found, register it to local table. If not,
+	 * consult actual system catalog and register it to local table.
+	 */
+	if (global_ct)
+	{
+		Handle *handle;
+
+		/*
+		 * Create local cache entry based on global cache entry. Refcount of
+		 * local entry is not bumped because it doesn't have tuple which
+		 * refcount would protect.
+		 */
+		handle = ((GlobalCatCTup *)global_ct)->gct_handle;
+
+		local_ct = CatalogCacheCreateEntry(local_cache,
+										   &global_ct->tuple, arguments,
+										   hashValue, local_hashIndex,
+										   global_ct->negative,
+										   handle);
+
+		/* There is no negative entry in GlobalCatCache */
+		return &global_ct->tuple;
 	}
+	else
+	{
+		/* Create local entry and also global entry if needed */
+		return SearchCatCacheMiss(local_cache, nkeys, hashValue,
+								  local_hashIndex, v1, v2, v3, v4);
 
-	return SearchCatCacheMiss(cache, nkeys, hashValue, hashIndex, v1, v2, v3, v4);
+	}
 }
 
 /*
@@ -1320,8 +1751,14 @@ SearchCatCacheMiss(CatCache *cache,
 	Relation	relation;
 	SysScanDesc scandesc;
 	HeapTuple	ntp;
-	CatCTup    *ct;
+	CatCTup    *local_ct;
 	Datum		arguments[CATCACHE_MAXKEYS];
+	GlobalCatCTup *gct = NULL;
+	Index global_hashIndex;
+	Handle* handle;
+	HeapTuple tuple = NULL;
+
+	Assert(cache->cc_type != CC_SHAREDGLOBAL);
 
 	/* Initialize local parameter array */
 	arguments[0] = v1;
